leetcode.560. Subarray Sum Equals K

Given an array of integers and an integer k, you need to find the total number of continuous subarrays whose sum equals to k.

Example 1:

Input:nums = [1,1,1], k = 2
Output: 2

Note:

  1. The length of the array is in range [1, 20,000].
  2. The range of numbers in the array is [-1000, 1000] and the range of the integer k is [-1e7, 1e7].

题意:

给定一个数组和目标值k,判断数组中有几个子数组,这些子数组的和为k。

思路:

1.暴力解法,从前向后遍历每一个元素,依次相加,复杂度为O(n2)。可能会超时。

//暴力破解
    public int subarraySum(int[] nums, int k) {
    	int count = 0;
    	for(int i = 0; i < nums.length; i++) {
    		int sum = nums[i];
    		if(sum == k) {
    			count++;
    		}
    		for(int j = i + 1; j < nums.length; j++) {
    			sum+= nums[j];
    			if(sum == k)
    				count++;
    		}
    	}
    	return count;
    }

2.记录数组的前缀的值。在这个问题中,最关键的问题是记录下sum[i,j]的值,避免重复计算,当从前向后遍历数组后,我们可以得到sum[0,i-1]和sum[0,j]的值,所以相减后可以得到sum[i,j]的值。为了记录出现过的值,我们使用hashmap记录所有出现过的前缀值,时间复杂度为O(n),空间复杂度为O(n)。

public int subarraySum(int[] nums, int k) {
        HashMap<Integer,Integer> map = new HashMap<>();
        //初始化
        map.put(0,1);
        int result = 0;
        int sum = 0;
        for(int i = 0; i < nums.length; i++) {
        	//sum为从前向后遍历数组的和
        	sum += nums[i];
        	//如果数组中出现过sum-k,说明前面有数组前缀值为k
        	if(map.containsKey(sum - k)) {
        		result += map.get(sum - k);
        	}
        	//sum放入hashmap
        	map.put(sum, map.getOrDefault(sum, 0) + 1);

        }
        return result;
    }

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值